#pragma once

#include "CoreMinimal.h"
#include "BaseBehaviourDetectionComponent.h"
#include "UObject/SoftObjectPtr.h"
#include "Templates/SubclassOf.h"
#include "DBDTunableRowHandle.h"
#include "BehaviourDetectionComponent_Tunneling.generated.h"

class UTunnelingIncentiveConfiguration;
class UActorComponent;
class UKillerUniqueHookCountComponent;
class ADBDPlayer;

UCLASS(Blueprintable, Abstract, meta=(BlueprintSpawnableComponent))
class DEADBYDAYLIGHT_API UBehaviourDetectionComponent_Tunneling : public UBaseBehaviourDetectionComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSoftObjectPtr<UTunnelingIncentiveConfiguration> _tunnelingIncentiveConfiguration;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UActorComponent> _lastHookedSurvivorComponentClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _numSurvivorsToHookBeforeUniqueHook;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _hasteDuration;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _hasteAmount;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _damageBonusAmount;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _survivorAuraRevealDuration;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _survivorAuraRevealDistance;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _numSurvivorsToHookBeforeSacrificePenalty;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _survivorRepairBonusAmount;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _bloodlustBonusAmount;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _bloodlustBonusDecayDelay;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	bool _disableUniqueHookIncentivesAfterConsecutiveHook;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	UKillerUniqueHookCountComponent* _killerUniqueHookCountComponent;

private:
	UFUNCTION(BlueprintCallable)
	void OnChaseStarted(ADBDPlayer* chasedPlayer);

public:
	UBehaviourDetectionComponent_Tunneling();
};

FORCEINLINE uint32 GetTypeHash(const UBehaviourDetectionComponent_Tunneling) { return 0; }
